//
//  Animation.h
//  WiiToMidi
//
//  Created by Mike Verdone on 29/01/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <WiiRemote/WiiRemote.h>

#define ANIM_FRAME_END 42
#define ANIM_FRAME_LOOP 43

#define ANIM_FLASH_1  0
#define ANIM_FLASH_2  4
#define ANIM_LR       8
#define ANIM_RL      14
#define ANIM_2UP     20
#define ANIM_2DOWN   24

@interface Animation : NSObject {
	int _frameWait;
	unsigned char *_frames;
	unsigned char _initialState;
	int _frameIdx;
	WiiRemote* _wii;
	NSTimer* _animTimer;
}

+(unsigned char*) getFramesWithId:(int) animationId;

-(id) initWithWiiRemote:(WiiRemote*)wii initialState:(unsigned char)state frameData:(unsigned char[])frameData;
-(id) animate:(NSTimer*) timer;
-(id) stopAnimation;
-(void) dealloc;

@end
