//
//  WiiStateArray.h
//  WiiToMidi
//
//  Created by Mike Verdone on 22/12/06.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <CoreMIDI/MIDIServices.h>

#define STATE_ARR_SIZE 54
#define SEND_ARR_SIZE 30

// Wii Remote accelerometers
#define SA_ACC_X 0
#define SA_ACC_Y 1
#define SA_ACC_Z 2

// Nunchuk accelerometers
#define SA_ACC_NX 3
#define SA_ACC_NY 4
#define SA_ACC_NZ 5

// Nunchuk joystick
#define SA_JOY_NX 6
#define SA_JOY_NY 7

// Classic joysticks
#define SA_JOY_CLX 8
#define SA_JOY_CLY 9
#define SA_JOY_CRX 10
#define SA_JOY_CRY 11

// Wii remote velocity
#define SA_VEL_X 12
#define SA_VEL_Y 13
#define SA_VEL_Z 14

// Nunchuk velocity
#define SA_VEL_NX 15
#define SA_VEL_NY 16
#define SA_VEL_NZ 17

// Wii remote position
#define SA_POS_X 18
#define SA_POS_Y 19
#define SA_POS_Z 20

// Nunchuk position
#define SA_POS_NX 21
#define SA_POS_NY 22
#define SA_POS_NZ 23

// Wii remote orientation
#define SA_ORI_X 24
// -- intentionally left blank --
#define SA_ORI_Y 26

// Nunchuk orientation
#define SA_ORI_NX 27
// -- intentionally left blank --
#define SA_ORI_NY 29

// Wii Remote buttons
#define SA_BUT_A 30
#define SA_BUT_B 31
#define SA_BUT_1 32
#define SA_BUT_2 33
#define SA_BUT_PLUS 34
#define SA_BUT_MINUS 35
#define SA_BUT_UP 36
#define SA_BUT_DOWN 37
#define SA_BUT_LEFT 38
#define SA_BUT_RIGHT 39

// Nunchuk buttons
#define SA_BUT_C 40
#define SA_BUT_Z 41

// Unsmoothed acceleration values
#define SA_ACC_RAWX 42
#define SA_ACC_RAWY 43
#define SA_ACC_RAWZ 44
#define SA_ACC_RAWNX 45
#define SA_ACC_RAWNY 46
#define SA_ACC_RAWNZ 47

// Classic controller buttons
#define SA_BUT_CA 48
#define SA_BUT_CB 49
#define SA_BUT_CX 50
#define SA_BUT_CY 51
#define SA_BUT_CL 52
#define SA_BUT_CR 53

#define SIGNAL_RANGE 256

typedef unsigned char* WiiStateArray;

typedef struct _WiiStateArrayNode
{
	unsigned char state[STATE_ARR_SIZE];
	struct _WiiStateArrayNode* next;
} WiiStateArrayNode;

