//
//  WiiStateArray.m
//  WiiToMidi
//
//  Created by Mike Verdone on 22/12/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import "WiiStateArray.h"

@implementation WiiStateArray

-(id) init
{
	bzero(self->_state, STATE_ARR_SIZE);
	self->_list = (MIDIPacketList*) malloc(MIDI_LIST_SIZE);
	self->_nextPacket = MIDIPacketListInit(self->_list);
	return self;
}

-(id) pushMidiData:(Byte*)data dataLen:(size_t)len
{
	self->_nextPacket = MIDIPacketListAdd(self->_list, MIDI_LIST_SIZE, self->_nextPacket, MIDI_TIME_NOW,
			len, data);
	return self;
}

-(id) release
{
	free(self->_list);
	self->_list = nil;
	return self;
}

-(MIDIPacketList*) midiData
{
	return self->_list;
}

-(Byte*) state
{
	return self->_state;
}

@end
