/*
 *  WiiStateArrayRing.c
 *  WiiToMidi
 *
 *  Created by Mike Verdone on 03/02/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#import "WiiStateArrayRing.h"

WiiStateArrayNode* createRing(int ringSize)
{
	int i;
	WiiStateArrayNode* firstNode;
	WiiStateArrayNode* prevNode;
	WiiStateArrayNode* node;
	
	firstNode = prevNode = (WiiStateArrayNode*) malloc(sizeof(WiiStateArrayNode));
	
	for (i = 1; i < ringSize; i++)
	{
		node = (WiiStateArrayNode*) malloc(sizeof(WiiStateArrayNode));
		prevNode->next = node;
		prevNode = node;
	}
	prevNode->next = firstNode;
	
	return firstNode;
}

void freeRing(WiiStateArrayNode* ring)
{
	WiiStateArrayNode* node = ring;
	WiiStateArrayNode* next;
	do
	{
		next = node->next;
		free(node);
		node = next;
	} while (node != ring);
}
