/* WiiToMidiController */

#import <Cocoa/Cocoa.h>
#import <WiiRemote/WiiRemote.h>
#import <WiiRemote/WiiRemoteDiscovery.h>

#import "WiiMidiDelegateObserver.h"
#import "WiiMidiDelegate.h"
#import "WiiRemoteDiscoveryAgent.h"
#import "MidiDevice.h"

@interface WiiToMidiController : NSObject <WiiMidiDelegateObserver>
{
    IBOutlet NSTextField *wiimoteMessage;
	IBOutlet NSPopUpButton *midiChannel;
	IBOutlet NSPopUpButton *midiDevice;
	IBOutlet NSTextField *_learnModeTF;
	IBOutlet NSTextField *_smoothingTF;
	IBOutlet NSTextField *_sensitivityTF;
	
	NSMutableArray *_midiDevices;
	
	WiiMidiDelegate *wiiMidiDelegate;
	WiiRemoteDiscoveryAgent* _wiiDiscoveryAgent;
}

-(IBAction) midiChannelChanged:(NSPopUpButton*)button;
-(IBAction) midiDeviceChanged:(NSPopUpButton*)button;

-(NSMutableArray*) midiDevices;

// Window delegate messages
-(void) windowWillClose:(NSNotification*)notification;

@end
